## cockpit-podman 25

=== Makefile ===
# extract name from package.json
PACKAGE_NAME := $(shell awk '/"name":/ {gsub(/[",]/, "", $$2); print $$2}' package.json)
RPM_NAME := cockpit-$(PACKAGE_NAME)
VERSION := $(shell T=$$(git describe 2>/dev/null) || T=1; echo $$T | tr '-' '.')
ifeq ($(TEST_OS),)
TEST_OS = fedora-32
endif
export TEST_OS
TARFILE=cockpit-$(PACKAGE_NAME)-$(VERSION).tar.gz
RPMFILE=$(shell rpmspec -D"VERSION $(VERSION)" -q cockpit-podman.spec.in).rpm
VM_IMAGE=$(CURDIR)/test/images/$(TEST_OS)
# stamp file to check if/when npm install ran
NODE_MODULES_TEST=package-lock.json
# one example file in dist/ from webpack to check if that already ran
WEBPACK_TEST=dist/index.css

WEBLATE_REPO=tmp/weblate-repo
WEBLATE_REPO_URL=https://github.com/cockpit-project/cockpit-podman-weblate.git
WEBLATE_REPO_BRANCH=master

all: $(WEBPACK_TEST)

#
# i18n
#

LINGUAS=$(basename $(notdir $(wildcard po/*.po)))

po/POTFILES.js.in:
	mkdir -p $(dir $@)
	find src/ -name '*.js' -o -name '*.jsx' > $@

po/$(PACKAGE_NAME).js.pot: po/POTFILES.js.in
	xgettext --default-domain=cockpit --output=$@ --language=C --keyword= \
		--keyword=_:1,1t --keyword=_:1c,2,1t --keyword=C_:1c,2 \
		--keyword=N_ --keyword=NC_:1c,2 \
		--keyword=gettext:1,1t --keyword=gettext:1c,2,2t \
		--keyword=ngettext:1,2,3t --keyword=ngettext:1c,2,3,4t \
		--keyword=gettextCatalog.getString:1,3c --keyword=gettextCatalog.getPlural:2,3,4c \
		--from-code=UTF-8 --files-from=$^

po/POTFILES.html.in:
	mkdir -p $(dir $@)
	find src -name '*.html' > $@

po/$(PACKAGE_NAME).html.pot: po/POTFILES.html.in $(NODE_MODULES_TEST)
	po/html2po -f $^ -o $@

po/$(PACKAGE_NAME).manifest.pot: $(NODE_MODULES_TEST)
	po/manifest2po src/manifest.json -o $@

po/$(PACKAGE_NAME).pot: po/$(PACKAGE_NAME).html.pot po/$(PACKAGE_NAME).js.pot po/$(PACKAGE_NAME).manifest.pot
	msgcat --sort-output --output-file=$@ $^

# Update translations against current PO template
update-po: po/$(PACKAGE_NAME).pot
	for lang in $(LINGUAS); do \
		msgmerge --output-file=po/$$lang.po po/$$lang.po $<; \
	done

dist/po.%.js: po/%.po $(NODE_MODULES_TEST)
	mkdir -p $(dir $@)
	po/po2json -m po/po.empty.js -o $@.js.tmp $<
	mv $@.js.tmp $@

$(WEBLATE_REPO):
	git clone --depth=1 -b $(WEBLATE_REPO_BRANCH) $(WEBLATE_REPO_URL) $(WEBLATE_REPO)

upload-pot: po/$(PACKAGE_NAME).pot $(WEBLATE_REPO)
	cp ./po/$(PACKAGE_NAME).pot $(WEBLATE_REPO)
	git -C $(WEBLATE_REPO) commit -m "Update source file" -- $(PACKAGE_NAME).pot
	git -C $(WEBLATE_REPO) push

clean-po:
	rm ./po/*.po

download-po: $(WEBLATE_REPO)
	cp $(WEBLATE_REPO)/*.po ./po/

#
# Build/Install/dist
#

%.spec: %.spec.in
	sed -e 's/%{VERSION}/$(VERSION)/g' $< > $@

$(WEBPACK_TEST): $(NODE_MODULES_TEST) lib/patternfly/_fonts.scss $(shell find src/ -type f) package.json webpack.config.js $(patsubst %,dist/po.%.js,$(LINGUAS))
	NODE_ENV=$(NODE_ENV) npm run build

watch:
	NODE_ENV=$(NODE_ENV) npm run watch

clean:
	rm -rf dist/
	[ ! -e $(RPM_NAME).spec.in ] || rm -f $(RPM_NAME).spec

install: $(WEBPACK_TEST)
	mkdir -p $(DESTDIR)/usr/share/cockpit/$(PACKAGE_NAME)
	cp -r dist/* $(DESTDIR)/usr/share/cockpit/$(PACKAGE_NAME)
	mkdir -p $(DESTDIR)/usr/share/metainfo/
	cp org.cockpit-project.$(PACKAGE_NAME).metainfo.xml $(DESTDIR)/usr/share/metainfo/

# this requires a built source tree and avoids having to install anything system-wide
devel-install: $(WEBPACK_TEST)
	mkdir -p ~/.local/share/cockpit
	ln -s `pwd`/dist ~/.local/share/cockpit/$(PACKAGE_NAME)

dist-gzip: $(TARFILE)

# when building a distribution tarball, call webpack with a 'production' environment
# we don't ship node_modules for license and compactness reasons; we ship a
# pre-built dist/ (so it's not necessary) and ship packge-lock.json (so that
# node_modules/ can be reconstructed if necessary)
$(TARFILE): NODE_ENV=production
$(TARFILE): $(WEBPACK_TEST) $(RPM_NAME).spec
	mv node_modules node_modules.release
	touch -r package.json $(NODE_MODULES_TEST)
	touch dist/*
	tar czf cockpit-$(PACKAGE_NAME)-$(VERSION).tar.gz --transform 's,^,cockpit-$(PACKAGE_NAME)/,' \
		--exclude $(RPM_NAME).spec.in \
		$$(git ls-files) lib/patternfly/*.scss package-lock.json $(RPM_NAME).spec dist/
	mv node_modules.release node_modules

srpm: $(TARFILE) $(RPM_NAME).spec
	rpmbuild -bs \
	  --define "_sourcedir `pwd`" \
	  --define "_srcrpmdir `pwd`" \
	  $(RPM_NAME).spec

rpm: $(RPMFILE)

$(RPMFILE): $(TARFILE) $(RPM_NAME).spec
	mkdir -p "`pwd`/output"
	mkdir -p "`pwd`/rpmbuild"
	rpmbuild -bb \
	  --define "_sourcedir `pwd`" \
	  --define "_specdir `pwd`" \
	  --define "_builddir `pwd`/rpmbuild" \
	  --define "_srcrpmdir `pwd`" \
	  --define "_rpmdir `pwd`/output" \
	  --define "_buildrootdir `pwd`/build" \
	  $(RPM_NAME).spec
	find `pwd`/output -name '*.rpm' -printf '%f\n' -exec mv {} . \;
	rm -r "`pwd`/rpmbuild"
	rm -r "`pwd`/output" "`pwd`/build"
	# sanity check
	test -e "$(RPMFILE)"

# determine what to depend on and do for Fedora/RHEL/Debian VM preparation
ifneq ($(filter debian-%,$(TEST_OS)),)
VM_DEP=$(TARFILE) packaging/debian/rules packaging/debian/control
VM_PACKAGE=--upload `pwd`/$(TARFILE):/var/tmp/ --upload `pwd`/packaging/debian:/var/tmp/
else
VM_DEP=$(RPMFILE)
VM_PACKAGE=--install cockpit-ws --install `pwd`/$(RPMFILE)
endif

ifeq ($(TEST_SCENARIO),rawhide)
# needs to run as a separate command, as --run-command is executed before --script
RAWHIDE=bots/image-customize -v --run-command 'dnf update -y --releasever=$$(. /etc/os-release; echo $$(( VERSION_ID + 1)) ) podman conmon crun containernetworking-plugins containers-common kernel' $(TEST_OS)
endif

# build a VM with locally built rpm/dsc installed
$(VM_IMAGE): $(VM_DEP) bots
	rm -f $(VM_IMAGE) $(VM_IMAGE).qcow2
	bots/image-customize -v $(VM_PACKAGE) -s $(CURDIR)/test/vm.install $(TEST_OS)
	$(RAWHIDE)

# convenience target for the above
vm: $(VM_IMAGE)
	echo $(VM_IMAGE)

# run the browser integration tests; skip check for SELinux denials
check: $(NODE_MODULES_TEST) $(VM_IMAGE) test/common
	TEST_AUDIT_NO_SELINUX=1 test/common/run-tests

# checkout Cockpit's bots for standard test VM images and API to launch them
# must be from master, as only that has current and existing images; but testvm.py API is stable
# support CI testing against a bots change
bots:
	git clone --quiet --reference-if-able $${XDG_CACHE_HOME:-$$HOME/.cache}/cockpit-project/bots https://github.com/cockpit-project/bots.git
	if [ -n "$$COCKPIT_BOTS_REF" ]; then git -C bots fetch --quiet --depth=1 origin "$$COCKPIT_BOTS_REF"; git -C bots checkout --quiet FETCH_HEAD; fi
	@echo "checked out bots/ ref $$(git -C bots rev-parse HEAD)"

# checkout Cockpit's test API; this has no API stability guarantee, so check out a stable tag
# when you start a new project, use the latest release, and update it from time to time
test/common:
	flock Makefile sh -ec '\
	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 228; \
	    git checkout --force FETCH_HEAD -- test/common; \
	    git reset test/common'

lib/patternfly/_fonts.scss:
	flock Makefile sh -ec '\
	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 227; \
	    mkdir -p pkg/lib/patternfly && git add pkg/lib/patternfly; \
	    git checkout --force FETCH_HEAD -- pkg/lib/patternfly; \
	    git reset -- pkg/lib/patternfly'
	mkdir -p lib && mv pkg/lib/patternfly lib/patternfly && rmdir -p pkg/lib

$(NODE_MODULES_TEST): package.json
	# if it exists already, npm install won't update it; force that so that we always get up-to-date packages
	rm -f package-lock.json
	# unset NODE_ENV, skips devDependencies otherwise
	env -u NODE_ENV npm install
	env -u NODE_ENV npm prune

.PHONY: all clean install devel-install dist-gzip srpm rpm check vm update-po

=== debian/changelog ===
cockpit-podman (25-1~ubuntu20.10.1) groovy-backports; urgency=medium

  * No-change backport to groovy

 -- Martin Pitt <mpitt@debian.org>  Mon, 14 Dec 2020 06:19:10 +0100

cockpit-podman (25-1) unstable; urgency=medium

  * Initial release (Closes: #967030)

 -- Martin Pitt <mpitt@debian.org>  Fri, 16 Oct 2020 16:28:02 +0200

## cockpit-podman 27.1

=== debian/changelog ===
cockpit-podman (27.1-1) unstable; urgency=medium

  * New upstream version.

 -- Martin Pitt <mpitt@debian.org>  Fri, 15 Jan 2021 06:00:51 +0100

cockpit-podman (25-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * No change source-only upload. 

 -- Boyuan Yang <byang@debian.org>  Thu, 14 Jan 2021 11:43:51 -0500

## cockpit-podman 28

=== Makefile ===
--- 
+++ 
@@ -3,21 +3,25 @@
 RPM_NAME := cockpit-$(PACKAGE_NAME)
 VERSION := $(shell T=$$(git describe 2>/dev/null) || T=1; echo $$T | tr '-' '.')
 ifeq ($(TEST_OS),)
-TEST_OS = fedora-32
+TEST_OS = fedora-33
 endif
 export TEST_OS
 TARFILE=cockpit-$(PACKAGE_NAME)-$(VERSION).tar.gz
-RPMFILE=$(shell rpmspec -D"VERSION $(VERSION)" -q cockpit-podman.spec.in).rpm
+RPMFILE=$(shell rpmspec -D"VERSION $(VERSION)" -q `ls cockpit-podman.spec.in cockpit-podman.spec 2>/dev/null | head -n1`).rpm
 VM_IMAGE=$(CURDIR)/test/images/$(TEST_OS)
 # stamp file to check if/when npm install ran
 NODE_MODULES_TEST=package-lock.json
 # one example file in dist/ from webpack to check if that already ran
-WEBPACK_TEST=dist/index.css
+WEBPACK_TEST=dist/manifest.json
+# one example file in src/lib to check if it was already checked out
+LIB_TEST=src/lib/cockpit-po-plugin.js
 
 WEBLATE_REPO=tmp/weblate-repo
 WEBLATE_REPO_URL=https://github.com/cockpit-project/cockpit-podman-weblate.git
 WEBLATE_REPO_BRANCH=master
 
+PYEXEFILES=$(shell git grep -lI '^#!.*python')
+
 all: $(WEBPACK_TEST)
 
 #
@@ -26,25 +30,17 @@
 
 LINGUAS=$(basename $(notdir $(wildcard po/*.po)))
 
-po/POTFILES.js.in:
-	mkdir -p $(dir $@)
-	find src/ -name '*.js' -o -name '*.jsx' > $@
-
-po/$(PACKAGE_NAME).js.pot: po/POTFILES.js.in
+po/$(PACKAGE_NAME).js.pot:
 	xgettext --default-domain=cockpit --output=$@ --language=C --keyword= \
 		--keyword=_:1,1t --keyword=_:1c,2,1t --keyword=C_:1c,2 \
 		--keyword=N_ --keyword=NC_:1c,2 \
 		--keyword=gettext:1,1t --keyword=gettext:1c,2,2t \
 		--keyword=ngettext:1,2,3t --keyword=ngettext:1c,2,3,4t \
 		--keyword=gettextCatalog.getString:1,3c --keyword=gettextCatalog.getPlural:2,3,4c \
-		--from-code=UTF-8 --files-from=$^
-
-po/POTFILES.html.in:
-	mkdir -p $(dir $@)
-	find src -name '*.html' > $@
-
-po/$(PACKAGE_NAME).html.pot: po/POTFILES.html.in $(NODE_MODULES_TEST)
-	po/html2po -f $^ -o $@
+		--from-code=UTF-8 $$(find src/ -name '*.js' -o -name '*.jsx')
+
+po/$(PACKAGE_NAME).html.pot: $(NODE_MODULES_TEST)
+	po/html2po -o $@ $$(find src -name '*.html')
 
 po/$(PACKAGE_NAME).manifest.pot: $(NODE_MODULES_TEST)
 	po/manifest2po src/manifest.json -o $@
@@ -58,11 +54,6 @@
 		msgmerge --output-file=po/$$lang.po po/$$lang.po $<; \
 	done
 
-dist/po.%.js: po/%.po $(NODE_MODULES_TEST)
-	mkdir -p $(dir $@)
-	po/po2json -m po/po.empty.js -o $@.js.tmp $<
-	mv $@.js.tmp $@
-
 $(WEBLATE_REPO):
 	git clone --depth=1 -b $(WEBLATE_REPO_BRANCH) $(WEBLATE_REPO_URL) $(WEBLATE_REPO)
 
@@ -84,7 +75,7 @@
 %.spec: %.spec.in
 	sed -e 's/%{VERSION}/$(VERSION)/g' $< > $@
 
-$(WEBPACK_TEST): $(NODE_MODULES_TEST) lib/patternfly/_fonts.scss $(shell find src/ -type f) package.json webpack.config.js $(patsubst %,dist/po.%.js,$(LINGUAS))
+$(WEBPACK_TEST): $(NODE_MODULES_TEST) $(LIB_TEST) $(shell find src/ -type f) package.json webpack.config.js
 	NODE_ENV=$(NODE_ENV) npm run build
 
 watch:
@@ -106,6 +97,7 @@
 	ln -s `pwd`/dist ~/.local/share/cockpit/$(PACKAGE_NAME)
 
 dist-gzip: $(TARFILE)
+	@ls -1 $(TARFILE)
 
 # when building a distribution tarball, call webpack with a 'production' environment
 # we don't ship node_modules for license and compactness reasons; we ship a
@@ -116,9 +108,9 @@
 	mv node_modules node_modules.release
 	touch -r package.json $(NODE_MODULES_TEST)
 	touch dist/*
-	tar czf cockpit-$(PACKAGE_NAME)-$(VERSION).tar.gz --transform 's,^,cockpit-$(PACKAGE_NAME)/,' \
+	tar czf $(TARFILE) --transform 's,^,cockpit-$(PACKAGE_NAME)/,' \
 		--exclude $(RPM_NAME).spec.in \
-		$$(git ls-files) lib/patternfly/*.scss package-lock.json $(RPM_NAME).spec dist/
+		$$(git ls-files) $(LIB_TEST) src/lib/patternfly/*.scss package-lock.json $(RPM_NAME).spec dist/
 	mv node_modules.release node_modules
 
 srpm: $(TARFILE) $(RPM_NAME).spec
@@ -147,7 +139,7 @@
 	test -e "$(RPMFILE)"
 
 # determine what to depend on and do for Fedora/RHEL/Debian VM preparation
-ifneq ($(filter debian-%,$(TEST_OS)),)
+ifneq ($(filter debian-% ubuntu-%,$(TEST_OS)),)
 VM_DEP=$(TARFILE) packaging/debian/rules packaging/debian/control
 VM_PACKAGE=--upload `pwd`/$(TARFILE):/var/tmp/ --upload `pwd`/packaging/debian:/var/tmp/
 else
@@ -165,10 +157,19 @@
 	rm -f $(VM_IMAGE) $(VM_IMAGE).qcow2
 	bots/image-customize -v $(VM_PACKAGE) -s $(CURDIR)/test/vm.install $(TEST_OS)
 	$(RAWHIDE)
+	# HACK: systemd kills the services after 90s
+	# See https://github.com/containers/podman/issues/8751
+	bots/image-customize -r "sed -i 's/Type=notify/Type=exec/' /usr/lib/systemd/system/podman.service" -r "sed -i 's/Type=notify/Type=exec/' /usr/lib/systemd/user/podman.service" $(TEST_OS)
+
 
 # convenience target for the above
 vm: $(VM_IMAGE)
 	echo $(VM_IMAGE)
+
+# run static code checks for python code
+codecheck:
+	python3 -m pyflakes $(PYEXEFILES)
+	python3 -m pycodestyle --max-line-length=195 $(PYEXEFILES) # TODO: Fix long lines
 
 # run the browser integration tests; skip check for SELinux denials
 check: $(NODE_MODULES_TEST) $(VM_IMAGE) test/common
@@ -186,17 +187,17 @@
 # when you start a new project, use the latest release, and update it from time to time
 test/common:
 	flock Makefile sh -ec '\
-	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 228; \
+	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 234; \
 	    git checkout --force FETCH_HEAD -- test/common; \
 	    git reset test/common'
 
-lib/patternfly/_fonts.scss:
+# checkout Cockpit's PF/React/build library; again this has no API stability guarantee, so check out a stable tag
+$(LIB_TEST):
 	flock Makefile sh -ec '\
-	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 227; \
-	    mkdir -p pkg/lib/patternfly && git add pkg/lib/patternfly; \
-	    git checkout --force FETCH_HEAD -- pkg/lib/patternfly; \
-	    git reset -- pkg/lib/patternfly'
-	mkdir -p lib && mv pkg/lib/patternfly lib/patternfly && rmdir -p pkg/lib
+	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 236; \
+	    git checkout --force FETCH_HEAD -- pkg/lib; \
+	    git reset -- pkg/lib'
+	mv pkg/lib src/ && rmdir -p pkg
 
 $(NODE_MODULES_TEST): package.json
 	# if it exists already, npm install won't update it; force that so that we always get up-to-date packages

=== debian/changelog ===
cockpit-podman (28-1) unstable; urgency=medium

  * New upstream version:
    - Drop cockpit-system dependency
    - Correctly show selected option for SELinux labels

 -- Martin Pitt <mpitt@debian.org>  Thu, 04 Feb 2021 13:05:34 +0100

=== debian/control ===
Source: cockpit-podman
Section: admin
Priority: optional
Maintainer: Martin Pitt <mpitt@debian.org>
Uploaders: Reinhard Tartler <siretart@tauware.de>
Build-Depends: debhelper-compat (= 12),
Standards-Version: 4.5.0
Homepage: https://github.com/cockpit-project/cockpit-podman
Vcs-Git: https://salsa.debian.org/debian/cockpit-podman.git
Vcs-Browser: https://salsa.debian.org/debian/cockpit-podman

Package: cockpit-podman
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
         cockpit-bridge (>= 138),
         cockpit-system (>= 138),
         podman (>= 2.0.4),
Description: Cockpit component for Podman containers
 The Cockpit Web Console enables users to administer GNU/Linux servers using a
 web browser.
 .
 This package adds an user interface for Podman containers.

=== debian/watch ===
version=3
https://github.com/cockpit-project/cockpit-podman/releases/ .*/cockpit-podman-([\d\.]+)\.tar\.gz

## cockpit-podman 29

=== Makefile ===
--- 
+++ 
@@ -187,14 +187,14 @@
 # when you start a new project, use the latest release, and update it from time to time
 test/common:
 	flock Makefile sh -ec '\
-	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 234; \
+	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 237; \
 	    git checkout --force FETCH_HEAD -- test/common; \
 	    git reset test/common'
 
 # checkout Cockpit's PF/React/build library; again this has no API stability guarantee, so check out a stable tag
 $(LIB_TEST):
 	flock Makefile sh -ec '\
-	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 236; \
+	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 237; \
 	    git checkout --force FETCH_HEAD -- pkg/lib; \
 	    git reset -- pkg/lib'
 	mv pkg/lib src/ && rmdir -p pkg

=== debian/changelog ===
cockpit-podman (29-1) unstable; urgency=medium

  * New upstream bug fix release:
    - PatternFly 4 updates for a more consistent UI
    - Accessibility fixes
  * Bump Standards-Version to 4.5.1.  No changes necessary.

 -- Martin Pitt <mpitt@debian.org>  Wed, 17 Mar 2021 08:46:26 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Martin Pitt <mpitt@debian.org>
 Uploaders: Reinhard Tartler <siretart@tauware.de>
 Build-Depends: debhelper-compat (= 12),
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://github.com/cockpit-project/cockpit-podman
 Vcs-Git: https://salsa.debian.org/debian/cockpit-podman.git
 Vcs-Browser: https://salsa.debian.org/debian/cockpit-podman

## cockpit-podman 33

=== debian/changelog ===
cockpit-podman (33-1) unstable; urgency=medium

  * New upstream release:
    - Fix crash with "Used Images" links
    - Translation updates

 -- Martin Pitt <mpitt@debian.org>  Sun, 22 Aug 2021 07:58:00 +0200

## cockpit-podman 34

=== Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 RPM_NAME := cockpit-$(PACKAGE_NAME)
 VERSION := $(shell T=$$(git describe 2>/dev/null) || T=1; echo $$T | tr '-' '.')
 ifeq ($(TEST_OS),)
-TEST_OS = fedora-33
+TEST_OS = fedora-34
 endif
 export TEST_OS
 TARFILE=cockpit-$(PACKAGE_NAME)-$(VERSION).tar.gz
@@ -18,7 +18,7 @@
 
 WEBLATE_REPO=tmp/weblate-repo
 WEBLATE_REPO_URL=https://github.com/cockpit-project/cockpit-podman-weblate.git
-WEBLATE_REPO_BRANCH=master
+WEBLATE_REPO_BRANCH=main
 
 PYEXEFILES=$(shell git grep -lI '^#!.*python')
 
@@ -103,7 +103,7 @@
 # we don't ship node_modules for license and compactness reasons; we ship a
 # pre-built dist/ (so it's not necessary) and ship packge-lock.json (so that
 # node_modules/ can be reconstructed if necessary)
-$(TARFILE): NODE_ENV=production
+$(TARFILE): export NODE_ENV=production
 $(TARFILE): $(WEBPACK_TEST) $(RPM_NAME).spec
 	mv node_modules node_modules.release
 	touch -r package.json $(NODE_MODULES_TEST)
@@ -144,12 +144,12 @@
 VM_PACKAGE=--upload `pwd`/$(TARFILE):/var/tmp/ --upload `pwd`/packaging/debian:/var/tmp/
 else
 VM_DEP=$(RPMFILE)
-VM_PACKAGE=--install cockpit-ws --install `pwd`/$(RPMFILE)
+VM_PACKAGE=--upload `pwd`/$(RPMFILE):/var/tmp/
 endif
 
 ifeq ($(TEST_SCENARIO),rawhide)
 # needs to run as a separate command, as --run-command is executed before --script
-RAWHIDE=bots/image-customize -v --run-command 'dnf update -y --releasever=$$(. /etc/os-release; echo $$(( VERSION_ID + 1)) ) podman conmon crun containernetworking-plugins containers-common kernel' $(TEST_OS)
+RAWHIDE=bots/image-customize -v --run-command 'dnf update -y --releasever=rawhide podman conmon crun containernetworking-plugins containers-common kernel' $(TEST_OS)
 endif
 
 # build a VM with locally built rpm/dsc installed
@@ -157,10 +157,6 @@
 	rm -f $(VM_IMAGE) $(VM_IMAGE).qcow2
 	bots/image-customize -v $(VM_PACKAGE) -s $(CURDIR)/test/vm.install $(TEST_OS)
 	$(RAWHIDE)
-	# HACK: systemd kills the services after 90s
-	# See https://github.com/containers/podman/issues/8751
-	bots/image-customize -r "sed -i 's/Type=notify/Type=exec/' /usr/lib/systemd/system/podman.service" -r "sed -i 's/Type=notify/Type=exec/' /usr/lib/systemd/user/podman.service" $(TEST_OS)
-
 
 # convenience target for the above
 vm: $(VM_IMAGE)
@@ -176,7 +172,7 @@
 	TEST_AUDIT_NO_SELINUX=1 test/common/run-tests
 
 # checkout Cockpit's bots for standard test VM images and API to launch them
-# must be from master, as only that has current and existing images; but testvm.py API is stable
+# must be from main, as only that has current and existing images; but testvm.py API is stable
 # support CI testing against a bots change
 bots:
 	git clone --quiet --reference-if-able $${XDG_CACHE_HOME:-$$HOME/.cache}/cockpit-project/bots https://github.com/cockpit-project/bots.git
@@ -187,14 +183,14 @@
 # when you start a new project, use the latest release, and update it from time to time
 test/common:
 	flock Makefile sh -ec '\
-	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 237; \
+	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 5a51e051af99a75f016bde33067904049beddf74; \
 	    git checkout --force FETCH_HEAD -- test/common; \
 	    git reset test/common'
 
 # checkout Cockpit's PF/React/build library; again this has no API stability guarantee, so check out a stable tag
 $(LIB_TEST):
 	flock Makefile sh -ec '\
-	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 237; \
+	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 248; \
 	    git checkout --force FETCH_HEAD -- pkg/lib; \
 	    git reset -- pkg/lib'
 	mv pkg/lib src/ && rmdir -p pkg

=== debian/changelog ===
cockpit-podman (34-1) unstable; urgency=medium

  * New upstream release:
    - First iteration of page redesign

 -- Martin Pitt <mpitt@debian.org>  Wed, 01 Sep 2021 18:34:55 +0200

=== debian/watch ===
version=4
https://github.com/cockpit-project/cockpit-podman/releases/ .*/cockpit-podman-([\d\.]+)\.tar\.gz

## cockpit-podman 36

=== Makefile ===
--- 
+++ 
@@ -6,7 +6,8 @@
 TEST_OS = fedora-34
 endif
 export TEST_OS
-TARFILE=cockpit-$(PACKAGE_NAME)-$(VERSION).tar.gz
+TARFILE=cockpit-$(PACKAGE_NAME)-$(VERSION).tar.xz
+NODE_CACHE=cockpit-$(PACKAGE_NAME)-node-$(VERSION).tar.xz
 RPMFILE=$(shell rpmspec -D"VERSION $(VERSION)" -q `ls cockpit-podman.spec.in cockpit-podman.spec 2>/dev/null | head -n1`).rpm
 VM_IMAGE=$(CURDIR)/test/images/$(TEST_OS)
 # stamp file to check if/when npm install ran
@@ -15,10 +16,6 @@
 WEBPACK_TEST=dist/manifest.json
 # one example file in src/lib to check if it was already checked out
 LIB_TEST=src/lib/cockpit-po-plugin.js
-
-WEBLATE_REPO=tmp/weblate-repo
-WEBLATE_REPO_URL=https://github.com/cockpit-project/cockpit-podman-weblate.git
-WEBLATE_REPO_BRANCH=main
 
 PYEXEFILES=$(shell git grep -lI '^#!.*python')
 
@@ -48,26 +45,6 @@
 po/$(PACKAGE_NAME).pot: po/$(PACKAGE_NAME).html.pot po/$(PACKAGE_NAME).js.pot po/$(PACKAGE_NAME).manifest.pot
 	msgcat --sort-output --output-file=$@ $^
 
-# Update translations against current PO template
-update-po: po/$(PACKAGE_NAME).pot
-	for lang in $(LINGUAS); do \
-		msgmerge --output-file=po/$$lang.po po/$$lang.po $<; \
-	done
-
-$(WEBLATE_REPO):
-	git clone --depth=1 -b $(WEBLATE_REPO_BRANCH) $(WEBLATE_REPO_URL) $(WEBLATE_REPO)
-
-upload-pot: po/$(PACKAGE_NAME).pot $(WEBLATE_REPO)
-	cp ./po/$(PACKAGE_NAME).pot $(WEBLATE_REPO)
-	git -C $(WEBLATE_REPO) commit -m "Update source file" -- $(PACKAGE_NAME).pot
-	git -C $(WEBLATE_REPO) push
-
-clean-po:
-	rm ./po/*.po
-
-download-po: $(WEBLATE_REPO)
-	cp $(WEBLATE_REPO)/*.po ./po/
-
 #
 # Build/Install/dist
 #
@@ -76,10 +53,10 @@
 	sed -e 's/%{VERSION}/$(VERSION)/g' $< > $@
 
 $(WEBPACK_TEST): $(NODE_MODULES_TEST) $(LIB_TEST) $(shell find src/ -type f) package.json webpack.config.js
-	NODE_ENV=$(NODE_ENV) npm run build
+	NODE_ENV=$(NODE_ENV) node_modules/.bin/webpack
 
 watch:
-	NODE_ENV=$(NODE_ENV) npm run watch
+	NODE_ENV=$(NODE_ENV) node_modules/.bin/webpack --watch
 
 clean:
 	rm -rf dist/
@@ -96,7 +73,7 @@
 	mkdir -p ~/.local/share/cockpit
 	ln -s `pwd`/dist ~/.local/share/cockpit/$(PACKAGE_NAME)
 
-dist-gzip: $(TARFILE)
+dist: $(TARFILE)
 	@ls -1 $(TARFILE)
 
 # when building a distribution tarball, call webpack with a 'production' environment
@@ -105,13 +82,16 @@
 # node_modules/ can be reconstructed if necessary)
 $(TARFILE): export NODE_ENV=production
 $(TARFILE): $(WEBPACK_TEST) $(RPM_NAME).spec
-	mv node_modules node_modules.release
 	touch -r package.json $(NODE_MODULES_TEST)
 	touch dist/*
-	tar czf $(TARFILE) --transform 's,^,cockpit-$(PACKAGE_NAME)/,' \
-		--exclude $(RPM_NAME).spec.in \
-		$$(git ls-files) $(LIB_TEST) src/lib/patternfly/*.scss package-lock.json $(RPM_NAME).spec dist/
-	mv node_modules.release node_modules
+	tar --xz -cf $(TARFILE) --transform 's,^,cockpit-$(PACKAGE_NAME)/,' \
+		--exclude $(RPM_NAME).spec.in --exclude node_modules \
+		$$(git ls-files) src/lib/ package-lock.json $(RPM_NAME).spec dist/
+
+$(NODE_CACHE): $(NODE_MODULES_TEST)
+	tar --xz -cf $@ node_modules
+
+node-cache: $(NODE_CACHE)
 
 srpm: $(TARFILE) $(RPM_NAME).spec
 	rpmbuild -bs \
@@ -143,8 +123,13 @@
 VM_DEP=$(TARFILE) packaging/debian/rules packaging/debian/control
 VM_PACKAGE=--upload `pwd`/$(TARFILE):/var/tmp/ --upload `pwd`/packaging/debian:/var/tmp/
 else
+ifneq ($(filter arch,$(TEST_OS)),)
+VM_DEP=$(TARFILE) packaging/arch/PKGBUILD
+VM_PACKAGE=--upload `pwd`/$(TARFILE):/var/tmp/ --upload `pwd`/packaging/arch:/var/tmp/
+else
 VM_DEP=$(RPMFILE)
 VM_PACKAGE=--upload `pwd`/$(RPMFILE):/var/tmp/
+endif
 endif
 
 ifeq ($(TEST_SCENARIO),rawhide)
@@ -183,14 +168,14 @@
 # when you start a new project, use the latest release, and update it from time to time
 test/common:
 	flock Makefile sh -ec '\
-	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 5a51e051af99a75f016bde33067904049beddf74; \
+	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 254; \
 	    git checkout --force FETCH_HEAD -- test/common; \
 	    git reset test/common'
 
 # checkout Cockpit's PF/React/build library; again this has no API stability guarantee, so check out a stable tag
 $(LIB_TEST):
 	flock Makefile sh -ec '\
-	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 248; \
+	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 5108999badee3834fcc8e57222b5f9c82feae3a9; \
 	    git checkout --force FETCH_HEAD -- pkg/lib; \
 	    git reset -- pkg/lib'
 	mv pkg/lib src/ && rmdir -p pkg
@@ -202,4 +187,4 @@
 	env -u NODE_ENV npm install
 	env -u NODE_ENV npm prune
 
-.PHONY: all clean install devel-install dist-gzip srpm rpm check vm update-po
+.PHONY: all clean install devel-install dist node-cache srpm rpm check vm

=== debian/changelog ===
cockpit-podman (36-1~bpo11+1) bullseye-backports; urgency=medium

  * No-change backport to Debian Bullseye

 -- Martin Pitt <mpitt@debian.org>  Mon, 15 Nov 2021 06:41:49 +0100

cockpit-podman (36-1) unstable; urgency=medium

  * New upstream release:
    - New "Create container" workflow
    - Prune unused images

 -- Martin Pitt <mpitt@debian.org>  Wed, 10 Nov 2021 11:54:30 +0100

## cockpit-podman 37

=== Makefile ===
--- 
+++ 
@@ -168,14 +168,14 @@
 # when you start a new project, use the latest release, and update it from time to time
 test/common:
 	flock Makefile sh -ec '\
-	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 254; \
+	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 257; \
 	    git checkout --force FETCH_HEAD -- test/common; \
 	    git reset test/common'
 
 # checkout Cockpit's PF/React/build library; again this has no API stability guarantee, so check out a stable tag
 $(LIB_TEST):
 	flock Makefile sh -ec '\
-	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 5108999badee3834fcc8e57222b5f9c82feae3a9; \
+	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 257; \
 	    git checkout --force FETCH_HEAD -- pkg/lib; \
 	    git reset -- pkg/lib'
 	mv pkg/lib src/ && rmdir -p pkg

=== debian/changelog ===
cockpit-podman (37-1) unstable; urgency=medium

  * New upstream release:
    - Improved image commit UI
    - PatternFly updates and fixes

 -- Martin Pitt <mpitt@debian.org>  Wed, 24 Nov 2021 16:09:55 +0100

## cockpit-podman 38

=== Makefile ===
--- 
+++ 
@@ -168,7 +168,7 @@
 # when you start a new project, use the latest release, and update it from time to time
 test/common:
 	flock Makefile sh -ec '\
-	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 257; \
+	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 8b00034ff0aa0dc8014aef32067559ccfb88afb2; \
 	    git checkout --force FETCH_HEAD -- test/common; \
 	    git reset test/common'

=== debian/changelog ===
cockpit-podman (38-1~bpo11+1) bullseye-backports; urgency=medium

  * No-change backport to Debian Bullseye

 -- Martin Pitt <mpitt@debian.org>  Wed, 15 Dec 2021 07:29:23 +0100

cockpit-podman (38-1) unstable; urgency=medium

  * New upstream release:
    - Updated translations
    - Consistent colors for pod and container running status

 -- Martin Pitt <mpitt@debian.org>  Thu, 09 Dec 2021 17:14:48 +0100

## cockpit-podman 39

=== debian/changelog ===
cockpit-podman (39-1) unstable; urgency=medium

  * New upstream release:
    - Create container in pod
    - Podman restart policy
    - Allow inserting multiple environment variables

 -- Martin Pitt <mpitt@debian.org>  Wed, 05 Jan 2022 16:16:19 +0100

## cockpit-podman 40

=== Makefile ===
--- 
+++ 
@@ -168,14 +168,14 @@
 # when you start a new project, use the latest release, and update it from time to time
 test/common:
 	flock Makefile sh -ec '\
-	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 8b00034ff0aa0dc8014aef32067559ccfb88afb2; \
+	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 259; \
 	    git checkout --force FETCH_HEAD -- test/common; \
 	    git reset test/common'
 
 # checkout Cockpit's PF/React/build library; again this has no API stability guarantee, so check out a stable tag
 $(LIB_TEST):
 	flock Makefile sh -ec '\
-	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 257; \
+	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 260; \
 	    git checkout --force FETCH_HEAD -- pkg/lib; \
 	    git reset -- pkg/lib'
 	mv pkg/lib src/ && rmdir -p pkg

=== debian/changelog ===
cockpit-podman (40-1~bpo11+1) bullseye-backports; urgency=medium

  * No-change backport to Debian Bullseye

 -- Martin Pitt <mpitt@debian.org>  Sun, 30 Jan 2022 08:42:26 +0100

cockpit-podman (40-1) unstable; urgency=medium

  * New upstream release:
    - Add pause/resume to containers
    - Always pull the latest image when creating a new container

 -- Martin Pitt <mpitt@debian.org>  Tue, 25 Jan 2022 08:38:53 +0100

## cockpit-podman 41

=== Makefile ===
--- 
+++ 
@@ -8,7 +8,8 @@
 export TEST_OS
 TARFILE=cockpit-$(PACKAGE_NAME)-$(VERSION).tar.xz
 NODE_CACHE=cockpit-$(PACKAGE_NAME)-node-$(VERSION).tar.xz
-RPMFILE=$(shell rpmspec -D"VERSION $(VERSION)" -q `ls cockpit-podman.spec.in cockpit-podman.spec 2>/dev/null | head -n1`).rpm
+SPEC=$(RPM_NAME).spec
+RPMFILE=$(shell rpmspec -D"VERSION $(VERSION)" -q `ls packaging/$(SPEC).in $(SPEC) 2>/dev/null | head -n1`).rpm
 VM_IMAGE=$(CURDIR)/test/images/$(TEST_OS)
 # stamp file to check if/when npm install ran
 NODE_MODULES_TEST=package-lock.json
@@ -49,7 +50,7 @@
 # Build/Install/dist
 #
 
-%.spec: %.spec.in
+%.spec: packaging/%.spec.in
 	sed -e 's/%{VERSION}/$(VERSION)/g' $< > $@
 
 $(WEBPACK_TEST): $(NODE_MODULES_TEST) $(LIB_TEST) $(shell find src/ -type f) package.json webpack.config.js
@@ -60,7 +61,7 @@
 
 clean:
 	rm -rf dist/
-	[ ! -e $(RPM_NAME).spec.in ] || rm -f $(RPM_NAME).spec
+	rm -f $(SPEC)
 
 install: $(WEBPACK_TEST)
 	mkdir -p $(DESTDIR)/usr/share/cockpit/$(PACKAGE_NAME)
@@ -81,27 +82,27 @@
 # pre-built dist/ (so it's not necessary) and ship packge-lock.json (so that
 # node_modules/ can be reconstructed if necessary)
 $(TARFILE): export NODE_ENV=production
-$(TARFILE): $(WEBPACK_TEST) $(RPM_NAME).spec
+$(TARFILE): $(WEBPACK_TEST) $(SPEC)
 	touch -r package.json $(NODE_MODULES_TEST)
 	touch dist/*
 	tar --xz -cf $(TARFILE) --transform 's,^,cockpit-$(PACKAGE_NAME)/,' \
-		--exclude $(RPM_NAME).spec.in --exclude node_modules \
-		$$(git ls-files) src/lib/ package-lock.json $(RPM_NAME).spec dist/
+		--exclude packaging/$(SPEC).in --exclude node_modules \
+		$$(git ls-files) src/lib/ package-lock.json $(SPEC) dist/
 
 $(NODE_CACHE): $(NODE_MODULES_TEST)
 	tar --xz -cf $@ node_modules
 
 node-cache: $(NODE_CACHE)
 
-srpm: $(TARFILE) $(RPM_NAME).spec
+srpm: $(TARFILE) $(SPEC)
 	rpmbuild -bs \
 	  --define "_sourcedir `pwd`" \
 	  --define "_srcrpmdir `pwd`" \
-	  $(RPM_NAME).spec
+	  $(SPEC)
 
 rpm: $(RPMFILE)
 
-$(RPMFILE): $(TARFILE) $(RPM_NAME).spec
+$(RPMFILE): $(TARFILE) $(SPEC)
 	mkdir -p "`pwd`/output"
 	mkdir -p "`pwd`/rpmbuild"
 	rpmbuild -bb \
@@ -111,7 +112,7 @@
 	  --define "_srcrpmdir `pwd`" \
 	  --define "_rpmdir `pwd`/output" \
 	  --define "_buildrootdir `pwd`/build" \
-	  $(RPM_NAME).spec
+	  $(SPEC)
 	find `pwd`/output -name '*.rpm' -printf '%f\n' -exec mv {} . \;
 	rm -r "`pwd`/rpmbuild"
 	rm -r "`pwd`/output" "`pwd`/build"
@@ -133,14 +134,13 @@
 endif
 
 ifeq ($(TEST_SCENARIO),rawhide)
-# needs to run as a separate command, as --run-command is executed before --script
-RAWHIDE=bots/image-customize -v --run-command 'dnf update -y --releasever=rawhide podman conmon crun containernetworking-plugins containers-common kernel' $(TEST_OS)
+UPGRADES=--run-command 'dnf update -y --releasever=rawhide podman conmon crun containernetworking-plugins containers-common kernel'
 endif
 
 # build a VM with locally built rpm/dsc installed
 $(VM_IMAGE): $(VM_DEP) bots
 	rm -f $(VM_IMAGE) $(VM_IMAGE).qcow2
-	bots/image-customize -v $(VM_PACKAGE) -s $(CURDIR)/test/vm.install $(TEST_OS)
+	bots/image-customize -v $(VM_PACKAGE) -s $(CURDIR)/test/vm.install $(UPGRADES) $(TEST_OS)
 	$(RAWHIDE)
 
 # convenience target for the above
@@ -168,14 +168,14 @@
 # when you start a new project, use the latest release, and update it from time to time
 test/common:
 	flock Makefile sh -ec '\
-	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 259; \
+	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 748cfe36086cdd7069c698d0193a1b4751a1b80e; \
 	    git checkout --force FETCH_HEAD -- test/common; \
 	    git reset test/common'
 
 # checkout Cockpit's PF/React/build library; again this has no API stability guarantee, so check out a stable tag
 $(LIB_TEST):
 	flock Makefile sh -ec '\
-	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 260; \
+	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 261; \
 	    git checkout --force FETCH_HEAD -- pkg/lib; \
 	    git reset -- pkg/lib'
 	mv pkg/lib src/ && rmdir -p pkg

=== debian/changelog ===
cockpit-podman (41-1) unstable; urgency=medium

  * New upstream release:
    - Adjust for podman 4.0 API break
    - Improve page layout on mobile devices

 -- Martin Pitt <mpitt@debian.org>  Wed, 02 Feb 2022 14:32:38 +0100

## cockpit-podman 42

=== debian/changelog ===
cockpit-podman (42-1) unstable; urgency=medium

  * New upstream release:
    - Tests improvements and stabilization

 -- Martin Pitt <mpitt@debian.org>  Wed, 16 Feb 2022 16:46:50 +0100

## cockpit-podman 44

=== Makefile ===
# extract name from package.json
PACKAGE_NAME := $(shell awk '/"name":/ {gsub(/[",]/, "", $$2); print $$2}' package.json)
RPM_NAME := cockpit-$(PACKAGE_NAME)
VERSION := $(shell T=$$(git describe 2>/dev/null) || T=1; echo $$T | tr '-' '.')
ifeq ($(TEST_OS),)
TEST_OS = fedora-35
endif
export TEST_OS
TARFILE=cockpit-$(PACKAGE_NAME)-$(VERSION).tar.xz
NODE_CACHE=cockpit-$(PACKAGE_NAME)-node-$(VERSION).tar.xz
SPEC=$(RPM_NAME).spec
APPSTREAMFILE=org.cockpit-project.$(PACKAGE_NAME).metainfo.xml
VM_IMAGE=$(CURDIR)/test/images/$(TEST_OS)
# stamp file to check if/when npm install ran
NODE_MODULES_TEST=package-lock.json
# one example file in dist/ from webpack to check if that already ran
WEBPACK_TEST=dist/manifest.json
# one example file in src/lib to check if it was already checked out
LIB_TEST=src/lib/cockpit-po-plugin.js

PYEXEFILES=$(shell git grep -lI '^#!.*python')

all: $(WEBPACK_TEST)

#
# i18n
#

LINGUAS=$(basename $(notdir $(wildcard po/*.po)))

po/$(PACKAGE_NAME).js.pot:
	xgettext --default-domain=$(PACKAGE_NAME) --output=$@ --language=C --keyword= \
		--keyword=_:1,1t --keyword=_:1c,2,2t --keyword=C_:1c,2 \
		--keyword=N_ --keyword=NC_:1c,2 \
		--keyword=gettext:1,1t --keyword=gettext:1c,2,2t \
		--keyword=ngettext:1,2,3t --keyword=ngettext:1c,2,3,4t \
		--keyword=gettextCatalog.getString:1,3c --keyword=gettextCatalog.getPlural:2,3,4c \
		--from-code=UTF-8 $$(find src/ -name '*.js' -o -name '*.jsx')

po/$(PACKAGE_NAME).html.pot: $(NODE_MODULES_TEST)
	po/html2po -o $@ $$(find src -name '*.html')

po/$(PACKAGE_NAME).manifest.pot: $(NODE_MODULES_TEST)
	po/manifest2po src/manifest.json -o $@

po/$(PACKAGE_NAME).metainfo.pot: $(APPSTREAMFILE)
	xgettext --default-domain=$(PACKAGE_NAME) --output=$@ $<

po/$(PACKAGE_NAME).pot: po/$(PACKAGE_NAME).html.pot po/$(PACKAGE_NAME).js.pot po/$(PACKAGE_NAME).manifest.pot po/$(PACKAGE_NAME).metainfo.pot
	msgcat --sort-output --output-file=$@ $^

po/LINGUAS:
	echo $(LINGUAS) | tr ' ' '\n' > $@

# Update translations against current PO template
update-po: po/$(PACKAGE_NAME).pot
	for lang in $(LINGUAS); do \
		msgmerge --output-file=po/$$lang.po po/$$lang.po $<; \
	done

#
# Build/Install/dist
#

%.spec: packaging/%.spec.in
	sed -e 's/%{VERSION}/$(VERSION)/g' $< > $@

packaging/arch/PKGBUILD: packaging/arch/PKGBUILD.in
	sed 's/VERSION/$(VERSION)/; s/SOURCE/$(TARFILE)/' $< > $@

packaging/debian/changelog: packaging/debian/changelog.in
	sed 's/VERSION/$(VERSION)/' $< > $@

$(WEBPACK_TEST): $(NODE_MODULES_TEST) $(LIB_TEST) $(shell find src/ -type f) package.json webpack.config.js
	NODE_ENV=$(NODE_ENV) node_modules/.bin/webpack

watch:
	NODE_ENV=$(NODE_ENV) node_modules/.bin/webpack --watch

clean:
	rm -rf dist/
	rm -f $(SPEC) packaging/arch/PKGBUILD packaging/debian/changelog
	rm -f po/LINGUAS

install: $(WEBPACK_TEST) po/LINGUAS
	mkdir -p $(DESTDIR)/usr/share/cockpit/$(PACKAGE_NAME)
	cp -r dist/* $(DESTDIR)/usr/share/cockpit/$(PACKAGE_NAME)
	mkdir -p $(DESTDIR)/usr/share/metainfo/
	msgfmt --xml -d po \
		--template $(APPSTREAMFILE) \
		-o $(DESTDIR)/usr/share/metainfo/$(APPSTREAMFILE)

# this requires a built source tree and avoids having to install anything system-wide
devel-install: $(WEBPACK_TEST)
	mkdir -p ~/.local/share/cockpit
	ln -s `pwd`/dist ~/.local/share/cockpit/$(PACKAGE_NAME)

dist: $(TARFILE)
	@ls -1 $(TARFILE)

# when building a distribution tarball, call webpack with a 'production' environment
# we don't ship node_modules for license and compactness reasons; we ship a
# pre-built dist/ (so it's not necessary) and ship packge-lock.json (so that
# node_modules/ can be reconstructed if necessary)
$(TARFILE): export NODE_ENV=production
$(TARFILE): $(WEBPACK_TEST) $(SPEC) packaging/arch/PKGBUILD packaging/debian/changelog
	touch -r package.json $(NODE_MODULES_TEST)
	touch dist/*
	tar --xz -cf $(TARFILE) --transform 's,^,cockpit-$(PACKAGE_NAME)/,' \
		--exclude '*.in' --exclude test/reference \
		$$(git ls-files) src/lib/ package-lock.json $(SPEC) packaging/arch/PKGBUILD packaging/debian/changelog dist/

$(NODE_CACHE): $(NODE_MODULES_TEST)
	tar --xz -cf $@ node_modules

node-cache: $(NODE_CACHE)

# convenience target for developers
rpm: $(TARFILE) $(SPEC)
	mkdir -p "`pwd`/output"
	mkdir -p "`pwd`/rpmbuild"
	rpmbuild -bb \
	  --define "_sourcedir `pwd`" \
	  --define "_specdir `pwd`" \
	  --define "_builddir `pwd`/rpmbuild" \
	  --define "_srcrpmdir `pwd`" \
	  --define "_rpmdir `pwd`/output" \
	  --define "_buildrootdir `pwd`/build" \
	  $(SPEC)
	find `pwd`/output -name '*.rpm' -printf '%f\n' -exec mv {} . \;
	rm -r "`pwd`/rpmbuild"
	rm -r "`pwd`/output" "`pwd`/build"

# build a VM with locally built distro pkgs installed
$(VM_IMAGE): $(TARFILE) packaging/debian/rules packaging/debian/control packaging/arch/PKGBUILD bots
	bots/image-customize --verbose --fresh --build $(TARFILE) --script $(CURDIR)/test/vm.install $(TEST_OS)

# convenience target for the above
vm: $(VM_IMAGE)
	echo $(VM_IMAGE)

# run static code checks for python code
codecheck:
	python3 -m pyflakes $(PYEXEFILES)
	python3 -m pycodestyle --max-line-length=195 $(PYEXEFILES) # TODO: Fix long lines

# run the browser integration tests; skip check for SELinux denials
check: $(NODE_MODULES_TEST) $(VM_IMAGE) test/common test/reference
	TEST_AUDIT_NO_SELINUX=1 test/common/run-tests

# checkout Cockpit's bots for standard test VM images and API to launch them
# must be from main, as only that has current and existing images; but testvm.py API is stable
# support CI testing against a bots change
bots:
	git clone --quiet --reference-if-able $${XDG_CACHE_HOME:-$$HOME/.cache}/cockpit-project/bots https://github.com/cockpit-project/bots.git
	if [ -n "$$COCKPIT_BOTS_REF" ]; then git -C bots fetch --quiet --depth=1 origin "$$COCKPIT_BOTS_REF"; git -C bots checkout --quiet FETCH_HEAD; fi
	@echo "checked out bots/ ref $$(git -C bots rev-parse HEAD)"

# checkout Cockpit's test API; this has no API stability guarantee, so check out a stable tag
# when you start a new project, use the latest release, and update it from time to time
test/common:
	flock Makefile sh -ec '\
	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 6e65510bc9dcf571d75fa592ed7b7c4d7cd3fc48; \
	    git checkout --force FETCH_HEAD -- test/common; \
	    git reset test/common'

test/reference: test/common
	test/common/pixel-tests pull

# checkout Cockpit's PF/React/build library; again this has no API stability guarantee, so check out a stable tag
$(LIB_TEST):
	flock Makefile sh -ec '\
	    git fetch --depth=1 https://github.com/cockpit-project/cockpit.git 261; \
	    git checkout --force FETCH_HEAD -- pkg/lib; \
	    git reset -- pkg/lib'
	mv pkg/lib src/ && rmdir -p pkg

$(NODE_MODULES_TEST): package.json
	# if it exists already, npm install won't update it; force that so that we always get up-to-date packages
	rm -f package-lock.json
	# unset NODE_ENV, skips devDependencies otherwise
	env -u NODE_ENV npm install
	env -u NODE_ENV npm prune

.PHONY: all clean install devel-install dist node-cache rpm check vm

=== debian/changelog ===
cockpit-podman (44-1~bpo11+1) bullseye-backports; urgency=medium

  * No-change backport to Debian Bullseye

 -- Martin Pitt <mpitt@debian.org>  Sun, 27 Mar 2022 08:20:26 +0200

cockpit-podman (44-1) unstable; urgency=medium

  * New upstream release:
    - Always use base 10 size units
    - Move owner option to details tab

 -- Martin Pitt <mpitt@debian.org>  Tue, 22 Mar 2022 06:15:17 +0100

## cockpit-podman 45

=== debian/changelog ===
cockpit-podman (45-1) unstable; urgency=medium

  * New upstream release:
    - Translation updates

 -- Martin Pitt <mpitt@debian.org>  Wed, 30 Mar 2022 16:13:55 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,8 @@
 Maintainer: Martin Pitt <mpitt@debian.org>
 Uploaders: Reinhard Tartler <siretart@tauware.de>
 Build-Depends: debhelper-compat (= 12),
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
+Rules-Requires-Root: no
 Homepage: https://github.com/cockpit-project/cockpit-podman
 Vcs-Git: https://salsa.debian.org/debian/cockpit-podman.git
 Vcs-Browser: https://salsa.debian.org/debian/cockpit-podman
@@ -14,7 +15,6 @@
 Multi-Arch: foreign
 Depends: ${misc:Depends},
          cockpit-bridge (>= 138),
-         cockpit-system (>= 138),
          podman (>= 2.0.4),
 Description: Cockpit component for Podman containers
  The Cockpit Web Console enables users to administer GNU/Linux servers using a

## cockpit-podman 46

=== debian/changelog ===
cockpit-podman (46-1) unstable; urgency=medium

  * New upstream release:
    - Translation updates

 -- Martin Pitt <mpitt@debian.org>  Wed, 13 Apr 2022 09:44:11 +0200

## cockpit-podman 50

=== debian/changelog ===
cockpit-podman (50-1~bpo22.04.1) jammy-backports; urgency=medium

  * No-change backport to jammy

 -- Martin Pitt <mpitt@debian.org>  Sun, 26 Jun 2022 07:31:05 +0200

cockpit-podman (50-1) unstable; urgency=medium

  * New upstream release:
    - Use NumberInput for Image Run Dialog

 -- Martin Pitt <mpitt@debian.org>  Thu, 23 Jun 2022 13:33:36 +0200

cockpit-podman (49.1-1) unstable; urgency=medium

  * New upstream release:
    - Container renaming
    - Health check support

 -- Martin Pitt <mpitt@debian.org>  Thu, 09 Jun 2022 11:07:15 +0200
